groups:
- name: Gitaly grpc handled
  interval: 1m
  rules:
  - record: gitaly_grpc:grpc_server_handled_total:rate1m
    expr: >
      sum without (fqdn,instance) (
       rate(grpc_server_handled_total{job="gitaly"}[1m])
      )
  - record: gitaly:grpc_server_handled_total:rate1m
    expr: >
      sum without (grpc_code) (
        gitaly_grpc:grpc_server_handled_total:rate1m
      )
  - record: gitaly:grpc_server_handled_total:error_rate1m
    expr: gitaly_grpc:grpc_server_handled_total:rate1m{grpc_code!="OK",grpc_code!="Canceled",grpc_code!="NotFound"}
  - record: gitaly:grpc_server_handled_total:instance_error_rate1m
    expr: >
      sum without (grpc_code, grpc_method, grpc_service, grpc_type) (
        rate(grpc_server_handled_total{job="gitaly",grpc_code!="OK"}[1m])
      )
  - alert: GitalyErrorRateTooHigh
    expr: gitaly:grpc_server_handled_total:error_rate1m > 2
    for: 5m
    labels:
      channel: gitaly
      pager: pagerduty
      severity: s1
    annotations:
      description: Gitaly {{$labels.grpc_code}} error rate for the last 5 minutes is over 2 for {{$labels.grpc_method}}.
        Check Gitaly logs and consider disabling that method.
      runbook: troubleshooting/gitaly-error-rate.md
      title: 'Gitaly error rate is too high: {{$value | printf "%.2f" }}'
  - alert: GitalyInstanceErrorRateTooHigh
    expr: gitaly:grpc_server_handled_total:instance_error_rate1m > 5
    for: 5m
    labels:
      channel: gitaly
      pager: pagerduty
      severity: s1
    annotations:
      description: Gitaly error rate for the last 5 minutes is over 5 on {{$labels.instance}}.
        Check Gitaly logs and consider disabling it on that host.
      runbook: troubleshooting/gitaly-error-rate.md
      title: 'Gitaly error rate is too high: {{$value | printf "%.2f" }}'

- name: Gitaly grpc buckets
  rules:
  - record: gitaly:grpc_server_handling_seconds_bucket:rate1m
    expr: >
      sum without (fqdn, instance, grpc_service, grpc_type) (
        rate(grpc_server_handling_seconds_bucket{job="gitaly"}[1m])
      )
  - record: gitaly_instance_grpc_method_code:grpc_server_handled_total:irate1m
    expr: >
      sum without (fqdn, instance, grpc_service, grpc_type) (
        irate(grpc_server_handled_total{job="gitaly"}[1m])
      )
  - record: gitaly:grpc_server_handling_seconds:avg5m
    expr: >
       avg without (fqdn, instance, grpc_service, grpc_type) (
         rate(grpc_server_handling_seconds_sum{job="gitaly"}[5m])
           /
         rate(grpc_server_handling_seconds_count{job="gitaly"}[5m]) > 0
       )

  - record: gitaly:grpc_server_handling_seconds:p95
    expr: >
      histogram_quantile(0.95,
        sum without (grpc_method, grpc_service, grpc_type) (
          rate(grpc_server_handling_seconds_bucket{job="gitaly"}[1m])
        )
      )
  - record: gitaly:grpc_server_handling_seconds:p50
    expr: >
      histogram_quantile(0.5,
        sum without (grpc_method, grpc_service, grpc_type) (
          rate(grpc_server_handling_seconds_bucket{job="gitaly"}[1m])
        )
      )
  - record: instance:gitaly_grpc_errors_total:rate1m
    expr: >
      sum without (grpc_method, grpc_type, grpc_service, grpc_code) (
        rate(grpc_server_handled_total{job="gitaly",grpc_code!="OK"}[1m])
      )

- name: Gitaly rate limiting
  rules:
  - record: gitaly:gitaly_rate_limiting_queued:grpc_method
    expr: sum(gitaly_rate_limiting_queued) by (environment, grpc_method, job)

- name: Gitaly misc alerts
  rules:
  - alert: GitalyFileServerDown
    expr: up{job="gitaly",tier="stor",type="gitaly"} == 0
    for: 1m
    labels:
      channel: gitaly
      pager: pagerduty
      severity: s1
    annotations:
      description: Gitaly has been marked as down for the past minute on {{$labels.instance}}.
        Check Gitaly logs and restart the process if necessary
      runbook: troubleshooting/gitaly-down.md
      title: Gitaly is down on {{ $labels.fqdn }}
  - alert: GitalyFileServerCPUUsage
    expr: >
      avg by (environment, fqdn) (
        instance:process_cpu_seconds_total:rate1m{job="gitaly",tier="stor",type="gitaly"}
      ) /
      avg by (environment, fqdn) (
        instance:node_cpus:count{tier="stor",type="gitaly"}
      ) * 100 > 50
    for: 1m
    labels:
      channel: gitaly
      pager: pagerduty
      severity: s1
    annotations:
      description: 'Gitaly has been using more than 50% of total available CPU on
        {{$labels.fqdn}} for the past minute. This may affect the stability of the
        NFS server. Visit this dashboard: https://dashboards.gitlab.net/dashboard/db/gitaly-nfs-metrics-per-host?refresh=30s&orgId=1&var-fqdn={{$labels.fqdn}}'
      runbook: troubleshooting/gitaly-high-cpu.md
      title: 'Gitaly: High CPU usage on {{ $labels.fqdn }}'
  - alert: GitalyVersionMismatch
    expr: >
      count(
        sum by (environment, version) (
          gitlab_build_info{tier="stor",type="gitaly"}
        ) > 0
      ) == 2
    for: 30m
    labels:
      channel: gitaly
      pager: pagerduty
      severity: s1
    annotations:
      description: During a deployment, two distinct versions of Gitaly may be running
        alongside one another, but this should not be the case for more than 30m.
        Visit https://dashboards.gitlab.net/dashboard/db/gitaly-version-tracker?orgId=1
        for details of versions deployed across the fleet.
      runbook: troubleshooting/gitaly-version-mismatch.md
      title: 'Gitaly: two versions of Gitaly have been running alongside one another
        in production for more than 30 minutes'
  - alert: GitalyVersionMismatchSevere
    expr: >
      count(
        sum by (environment, version) (
         gitlab_build_info{tier="stor",type="gitaly"}
        ) > 0
      ) > 2
    for: 1m
    labels:
      channel: gitaly
      pager: pagerduty
      severity: s1
    annotations:
      description: Three of more versions of Gitaly are currently running alongside
        one another in production. This should never occur and indicates serious deployment
        failures. Visit https://dashboards.gitlab.net/dashboard/db/gitaly-version-tracker?orgId=1
        for details of versions deployed across the fleet.
      runbook: troubleshooting/gitaly-version-mismatch.md
      title: 'Gitaly: multiple versions of Gitaly are currently running in production'

- name: Misc Gitaly Alerts
  rules:
  - alert: GitalyPubSubSendRateLow
    expr: |
      stackdriver_pubsub_topic_pubsub_googleapis_com_topic_send_message_operation_count{topic_id="pubsub-gitaly-inf-gprd"} / 60 < 100
    for: 5m
    labels:
      channel: g_gitaly
      severity: s4
    annotations:
      description: >
        Reach out to the Gitaly team, ensure logging is set properly.
      runbook: troubleshooting/gitaly-pubsub.md
      title: Gitaly PubSub send operation is low

  - alert: GitLabComLatencyGitalyCritical
    expr: gitaly:grpc_server_handling_seconds:p95 >= 60
    for: 5m
    labels:
      pager: pagerduty
      severity: s1
    annotations:
      description: Reach out to the Gitaly team and mitigate the problem restarting
        gitaly on the affected node if it's causing a partial outage.
      runbook: troubleshooting/gitaly-latency.md
      title: Gitaly latency on {{ $labels.fqdn }} has been over 1m during the last 5m

  - alert: gitaly_lock_acquisition_rates
    expr: |
      1 - (
        sum(rate(gitaly_rate_limiting_acquiring_seconds_bucket{le="60"}[10m])) by (environment, tier, type, stage, fqdn, grpc_method)
        /
        sum(rate(gitaly_rate_limiting_acquiring_seconds_bucket{le="+Inf"}[10m])) by (environment, tier, type, stage, fqdn, grpc_method)
      ) > 0.2
    for: 10m
    labels:
      rules_domain: general
      type: gitaly
      metric: gitaly_rate_limiting_acquiring_seconds_bucket
      severity: s4
      period: 10m
    annotations:
      title: "More than 20% of Gitaly {{ $labels.grpc_method }} requests to {{ $labels.fqdn }} are queueing for more than 60s"
      description: >
        An extremely high proportion of Gitaly  {{ $labels.grpc_method }} requests to {{ $labels.fqdn }} are being queued up for an extended period.

        This issue is likely to be immediately client-impacting.
      grafana_dashboard_id: "VBaSC9aik/gitaly-rate-limiting-alerting"
      grafana_panel_id: "2"
      grafana_variables: "environment,stage,grpc_method"
      grafana_min_zoom_hours: "6"
      runbook: "troubleshooting/gitaly-rate-limiting.md"
      promql_template_1: 'histogram_quantile(0.80, sum(rate(gitaly_rate_limiting_acquiring_seconds_bucket{stage="$stage",grpc_method="$grpc_method"}[1m])) by (fqdn, grpc_method, le))'
